Attribute VB_Name = "CamLib"
'-----------------------------------------------------------------------------
'
'    Camlib definitions
'
'-----------------------------------------------------------------------------
'
'    Revision History.
'
'-----------------------------------------------------------------------------
Option Explicit

'Dim gain
'Dim x
'Dim camera

Public Const MAX_CAMERA_DESCRIPTION = 32
Public Const MAX_CAMERAS = 10
Public Const MAX_CAPTURE_HISTOGRAM_BINS = 256

Declare Function open_cam Lib "camlib.dll" (ByVal client_type As CAM_CLIENT_TYPES) As Long
Declare Sub close_cam Lib "camlib.dll" ()
Declare Sub reset_cam Lib "camlib.dll" ()

Declare Function num_cameras Lib "camlib.dll" () As Long
Declare Function alloc_capture Lib "camlib.dll" (ByVal camera As Long) As Long
Declare Function free_capture Lib "camlib.dll" (ByVal Capture As Long) As Long
Declare Function chain_capture Lib "camlib.dll" (ByVal Capture As Long, ByVal dest As Long) As Long
Declare Function capture_control Lib "camlib.dll" (ByVal Capture As Long, ByVal control_type As CAPTURE_CONTROL_TYPES) As Long

Declare Function setup_capture Lib "camlib.dll" (ByVal Capture As Long, ByVal cam_mode As CAM_OPERATION_MODES, ByVal Rate As Double, ByRef cam As CAM_WINDOW, ByVal Res As Long, ByVal integration_time As Double, ByVal gain As Double, ByVal capture_type As CAM_CAPTURE_TYPES, ByVal cam_format As CAM_FORMAT_TYPES, ByRef buff_size As Long, ByRef adj As CAPTURE_IMAGE_ADJUSTMENT) As Long
Declare Function setup_timer_capture Lib "camlib.dll" (ByVal Capture As Long, ByVal Rate As Double, ByRef dest As DEST_WINDOW, ByVal cam_mode As CAM_OPERATION_MODES, ByRef cam As CAM_WINDOW, ByVal Res As Long, ByVal integration_time As Double, ByVal gain As Double, ByRef adj As CAPTURE_IMAGE_ADJUSTMENT) As Long
Declare Function reset_capture Lib "camlib.dll" (ByVal Capture As Long) As Long
Declare Function start_capture_render Lib "camlib.dll" (ByVal Capture As Long, ByRef dest As DEST_WINDOW) As Long
Declare Function stop_capture_render Lib "camlib.dll" (ByVal Capture As Long) As Long
Declare Function capture_occured Lib "camlib.dll" (ByVal Capture As Long, ByRef info As CAPTURE_FRAME_INFO) As Long
Declare Function capture_overlay Lib "camlib.dll" (ByVal Capture As Long, ByVal coordinate_type As CAPTURE_COORDINATE_TYPES, ByVal overlay_type As CAPTURE_OVERLAY_TYPES, ByVal bitmap_handle As Long, ByVal cx As Long, ByVal cy As Long, ByVal transparent_colour As Long) As Long
Declare Function capture_cursor Lib "camlib.dll" (ByVal Capture As Long, ByVal coordinate_type As CAPTURE_COORDINATE_TYPES, ByVal cursor_type As CAPTURE_CURSOR_TYPES, ByVal cx As Long, ByVal cy As Long, ByVal cursor_colour As Long, ByVal angle As Double) As Long
Declare Function force_capture Lib "camlib.dll" (ByVal Capture As Long) As Long
Declare Function get_capture_params Lib "camlib.dll" (ByVal Capture As Long, ByRef params As CAPTURE_REQUIREMENT_PARAMS) As Long
Declare Function get_frame_info Lib "camlib.dll" (ByVal Capture As Long, ByRef info As CAPTURE_FRAME_INFO) As Long
Declare Function hook_capture_callback Lib "camlib.dll" (ByVal Capture As Long, ByVal context As Long, ByVal pCallback As Long) As Long
Declare Function get_capture_camera_id Lib "camlib.dll" (ByVal Capture As Long) As Long

Declare Function copy_capture_buffer Lib "camlib.dll" (ByVal Capture As Long, ByVal BufferPtr As Long, ByRef info As CAPTURE_FRAME_INFO) As Long
Declare Function flush_capture_buffer Lib "camlib.dll" (ByVal Capture As Long) As Long

Declare Function setup_auto_adjust Lib "camlib.dll" (ByVal Capture As Long, ByRef params As CAPTURE_AUTO_ADJUST_PARAMS) As Long
Declare Function get_auto_adjust_params Lib "camlib.dll" (ByVal Capture As Long, ByRef params As CAPTURE_AUTO_ADJUST_PARAMS) As Long
Declare Function setup_sync Lib "camlib.dll" (ByVal camera As Long, ByVal sync As Long, ByRef params As CAPTURE_SYNC_PARAMETERS) As Long

Declare Function set_capture_render_config Lib "camlib.dll" (ByVal Capture As Long, ByRef config As CAPTURE_RENDER_CONFIG) As Long
Declare Function get_capture_render_config Lib "camlib.dll" (ByVal Capture As Long, ByRef config As CAPTURE_RENDER_CONFIG) As Long

Declare Function setup_colour_correction Lib "camlib.dll" (ByVal Capture As Long, ByRef params As COLOUR_CORRECTION_PARAMS) As Long

Declare Function read_current_capture_user_data Lib "camlib.dll" (ByVal Capture As Long, dest As Any, ByVal sz As Long) As Long
Declare Function write_current_capture_user_data Lib "camlib.dll" (ByVal Capture As Long, src As Any, ByVal sz As Long) As Long

Declare Function get_camera_settings Lib "camlib.dll" (ByVal camera As Long, ByRef settings As CAMERA_SETTINGS) As Long
Declare Function set_camera_settings Lib "camlib.dll" (ByVal camera As Long, ByRef settings As CAMERA_SETTINGS) As Long

Declare Sub set_register Lib "camlib.dll" (ByVal camera As Long, ByVal reg As Byte, ByVal data As Integer)

'These are private wrapped 'alias' functions
Private Declare Function enumerate_cameras_lib Lib "camlib.dll" Alias "enumerate_cameras" (ByRef ident As CAM_IDENTIFICATION_LIB, ByVal num_idents As Long) As Long
Private Declare Function get_camera_id_lib Lib "camlib.dll" Alias "get_camera_id" (ByRef descr As Byte) As Long
Private Declare Function get_camera_description_lib Lib "camlib.dll" Alias "get_camera_description" (ByVal camera As Long, ByRef descr As Byte, ByVal descr_len As Long) As Long
Private Declare Function set_camera_description_lib Lib "camlib.dll" Alias "set_camera_description" (ByVal camera As Long, ByRef descr As Byte) As Long

Enum CAM_FORMAT_TYPES
    CAM_RAW = 0
    CAM_RGB32 = 1
    CAM_RGB24 = 2
    CAM_RGBBYTE = 20
    CAM_RGBDOUBLE = 21
    CAM_GREYBYTE = 22
End Enum

Enum CAM_CLIENT_TYPES
    CAM_CLIENT_USER_TYPE = 0
    CAM_CLIENT_WDM_TYPE = 1
End Enum

Enum CAPTURE_COORDINATE_TYPES
    CAPTURE_COORDINATE_CAM = 0
    CAPTURE_COORDINATE_WINDOW = 1
End Enum

Enum CAPTURE_OVERLAY_TYPES
    CAPTURE_OVERLAY_OFF = 0
    CAPTURE_OVERLAY_STANDARD = 1
    CAPTURE_OVERLAY_RAW_HISTOGRAM = 2
    CAPTURE_OVERLAY_ADJUSTED_HISTOGRAM = 3
End Enum

Enum CAPTURE_CURSOR_TYPES
    CAPTURE_CURSOR_OFF = 0
    CAPTURE_CURSOR_CROSS_HAIRS = 1
    CAPTURE_CURSOR_CROSS_HAIRS_DASHED = 2
End Enum

Enum COLOUR_CORRECTION_TYPES
    COLOUR_CORRECTION_OFF = 0
    COLOUR_CORRECTION_ON = 1
End Enum

Enum CAM_OPERATION_MODES
    CAM_STANDARD_RES_FULL_SPEED = 0
    CAM_HIGH_RES_HALF_SPEED = 1
End Enum

Enum CAM_CAPTURE_TYPES
    CAPTURE_STOP = 0
    CAPTURE_IMMEDIATE = 1
    CAPTURE_ON_PROBE = 2
    CAPTURE_REPEAT = 3
End Enum

Enum CAM_SYNC_TYPES
    CAM_SYNC_OFF = 0
    CAM_SYNC_CAPTURE_PULSE = 1
    CAM_SYNC_CAPTURE_SET = 2
End Enum

Enum CAPTURE_AUTO_EXPOSURE_MODES
    CAPTURE_AUTO_EXPOSURE_OFF = 0
    CAPTURE_AUTO_EXPOSURE_GAIN = 1
    CAPTURE_AUTO_EXPOSURE_INTEGRATION_TIME = 2
    CAPTURE_AUTO_EXPOSURE_GAIN_AND_INTEGRATION_RATIO = 3
    CAPTURE_AUTO_EXPOSURE_GAIN_AND_INTEGRATION_MIN_TO_MAX = 4
End Enum

Enum CAPTURE_AUTO_ADJUST_MODES
    CAPTURE_AUTO_ADJUST_OFF = 0
    CAPTURE_AUTO_ADJUST_ON = 1
End Enum

Enum CAPTURE_CALLBACK_TYPES
    CAPTURE_CALLBACK_CAPTURE_OCCURRED = 1
    CAPTURE_CALLBACK_CAPTURE_ERROR = 2
End Enum

Enum CAPTURE_CONTROL_TYPES
    CAPTURE_CONTROL_TYPE_STOP = 0
    CAPTURE_CONTROL_TYPE_PAUSE = 1
    CAPTURE_CONTROL_TYPE_PLAY = 2
    CAPTURE_CONTROL_TYPE_FRAME_ADVANCE = 3
End Enum

Enum CAPTURE_IMAGE_ADUSTMENT_TYPES
    CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR = 0
    CAPTURE_IMAGE_ADJUSTMENT_COMBINED_COLOURS = 1
End Enum

Type CAM_IDENTIFICATION
    id As Long
    max_capture_size As Long
    descr As String
End Type

Type CAM_IDENTIFICATION_LIB
    id As Long
    max_capture_size As Long
    descr(MAX_CAMERA_DESCRIPTION - 1) As Byte
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAM_WINDOW
    cx As Long
    cy As Long
    dx As Long
    dy As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type DEST_WINDOW
    hwnd As Long
    ox As Long
    oy As Long
    dx As Long
    dy As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_COLOUR_ADJUSTMENT
    contrast As Double
    brightness As Double
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_IMAGE_ADJUSTMENT
    rgbColourAdjust As CAPTURE_COLOUR_ADJUSTMENT
    redColourAdjust As CAPTURE_COLOUR_ADJUSTMENT
    greenColourAdjust As CAPTURE_COLOUR_ADJUSTMENT
    blueColourAdjust As CAPTURE_COLOUR_ADJUSTMENT
    greyscale As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_REQUIREMENT_PARAMS
    image_adjustment As CAPTURE_IMAGE_ADJUSTMENT
    cam As CAM_WINDOW
    gain As Double
    integration_time As Double
    Rate As Double
    cam_mode As CAM_OPERATION_MODES
    capture_type As CAM_CAPTURE_TYPES
    cam_format As CAM_FORMAT_TYPES
    Res As Long
    frame_size As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_HISTOGRAM
    total As Long
    sum As Long
    min As Long
    max As Long
    mean As Long
    clipped As Long
    pad2  As Long
    pad3  As Long
    bin(MAX_CAPTURE_HISTOGRAM_BINS - 1) As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_AUTO_EXPOSURE_PARAMS
    flicker_frequency As Double
    nominal_gain As Double
    min_gain As Double
    max_gain As Double
    nominal_integration_time As Double
    min_integration_time As Double
    max_integration_time As Double
    gain_and_intgegration_time_ratio As Double
    exposure_mode As CAPTURE_AUTO_EXPOSURE_MODES
    num_filter_frames As Long
    pad1 As Long
    pad2 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_AUTO_ADJUST_PARAMS
    exposure As CAPTURE_AUTO_EXPOSURE_PARAMS
    adjust_mode As CAPTURE_AUTO_ADJUST_MODES
    adjustment_type As CAPTURE_IMAGE_ADUSTMENT_TYPES
    min_threshold As Double
    max_threshold As Double
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_FRAME_INFO
    params As CAPTURE_REQUIREMENT_PARAMS
    auto_adjust As CAPTURE_AUTO_ADJUST_PARAMS
    rgbHist As CAPTURE_HISTOGRAM
    redHist As CAPTURE_HISTOGRAM
    greenHist As CAPTURE_HISTOGRAM
    blueHist As CAPTURE_HISTOGRAM
    focus As Double
    frame_number As Long
    time_stamp As Long
    num_missed_pixels As Long
    pad1 As Long
    frame_quality As Double
    sync_valid As Integer
    spare3 As Integer
    spare4 As Integer
    actual_rate As Double
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_SYNC_PARAMETERS
    sync_type As CAM_SYNC_TYPES
    invert_logic As Long
    Capture As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_CALLBACK_MSG
    callback_type As CAPTURE_CALLBACK_TYPES
    param As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_OVERLAY_DEF
    coordinate_type As CAPTURE_COORDINATE_TYPES
    overlay_type As CAPTURE_OVERLAY_TYPES
    cx As Long
    cy As Long
    transparent_colour As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_CURSOR_DEF
    coordinate_type As CAPTURE_COORDINATE_TYPES
    cursor_type As CAPTURE_CURSOR_TYPES
    cx As Long
    cy As Long
    angle As Double
    colour As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_RENDER_CONFIG
    display_short_frames As Long
    pad1 As Long
    spare1 As Long
    spare2 As Long
    spare3 As Long
    spare4 As Long
    spare5 As Long
    spare6 As Long
    spare7 As Long
    spare8 As Long
End Type

Type CAPTURE_REQUIREMENT_DEF
    camera As Long
    pCallback As Long
    requirement As CAPTURE_REQUIREMENT_PARAMS
    auto_adjust As CAPTURE_AUTO_ADJUST_PARAMS
End Type

Type COLOUR_WEIGHT
    redcomp As Double
    greencomp As Double
    bluecomp As Double
End Type

Type COLOUR_MATRIX
    pixelscale As Double
    pixelred As COLOUR_WEIGHT
    pixelgreen As COLOUR_WEIGHT
    pixelblue As COLOUR_WEIGHT
End Type

Type COLOUR_CORRECTION_PARAMS
    correction_type As COLOUR_CORRECTION_TYPES
    spare1 As Long
    matrix As COLOUR_MATRIX
End Type

Type CAMERA_SETTINGS
    Description(MAX_CAMERA_DESCRIPTION - 1) As Byte
    vertical_flip As Long
    spare11 As Long
    spare10 As Long
    spare9 As Long
    spare8 As Long
    spare7 As Long
    spare6 As Long
    spare5 As Long
    spare4 As Long
    spare3 As Long
    spare2 As Long
    spare1 As Long
End Type

Private Function Trim0(sName As String) As String
   ' Right trim string at first null.
   Dim x As Integer
   x = InStr(sName, vbNullChar)
   If x > 0 Then Trim0 = Left$(sName, x - 1) Else Trim0 = sName
End Function

Public Function enumerate_cameras(ByRef ident() As CAM_IDENTIFICATION) As Long
    
    Dim cams(MAX_CAMERAS - 1) As CAM_IDENTIFICATION_LIB
    Dim num As Long
    Dim i As Integer
    
    num = enumerate_cameras_lib(cams(0), MAX_CAMERAS)

    ReDim ident(num + 1) As CAM_IDENTIFICATION
            
    For i = 0 To num - 1
        ident(i).id = cams(i).id
        ident(i).max_capture_size = cams(i).max_capture_size
        ident(i).descr = Trim0(StrConv(cams(i).descr, vbUnicode))
    Next i
    
    ident(i).id = 0
    ident(i).descr = ""
    
    enumerate_cameras = num
    
End Function


Public Function get_camera_id(ByRef descr As String) As Long
    Dim ansistr() As Byte
    Dim cBytes As Long
    
    cBytes = Len(descr)
    
    ansistr = StrConv(descr, vbFromUnicode)
    
    ReDim Preserve ansistr(cBytes)
    ansistr(cBytes) = 0

    get_camera_id = get_camera_id_lib(ansistr(0))
    
End Function

Public Function get_camera_description(ByVal camera As Long, ByRef descr As String) As Long
    Dim ansistr(MAX_CAMERA_DESCRIPTION) As Byte
    
    get_camera_description = get_camera_description_lib(camera, ansistr(0), MAX_CAMERA_DESCRIPTION)
    descr = Trim0(StrConv(ansistr, vbUnicode))

End Function

Public Function set_camera_description(ByVal camera As Long, ByRef descr As String) As Long
    Dim ansistr() As Byte
    Dim cBytes As Long
    
    cBytes = Len(descr)
    
    ansistr = StrConv(descr, vbFromUnicode)
    
    ReDim Preserve ansistr(cBytes)
    ansistr(cBytes) = 0
    
    set_camera_description = set_camera_description_lib(camera, ansistr(0))

End Function





