// Example1Dlg.cpp : implementation file
//
// This example code sets up a capture stream at a specified frame rate to the user app's window and
// a single, still frame capture triggered by a button shows how to collect and process image data
// 

#include "stdafx.h"
#include "Example1.h"
#include "Example1Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "camgen.h"
#include "camcapture.h"
#include "lghtlib.h"

unsigned long gTimerCapture=0;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExample1Dlg dialog

CExample1Dlg::CExample1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExample1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExample1Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExample1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExample1Dlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_LIGHTING_CHECK, m_LightsCheckBox);
}

BEGIN_MESSAGE_MAP(CExample1Dlg, CDialog)
	//{{AFX_MSG_MAP(CExample1Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CAPTURE, OnButtonCapture)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LIGHTING_CHECK, &CExample1Dlg::OnLighting)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExample1Dlg message handlers

BOOL CExample1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	// This example code sets up a capture stream at a specified frame rate to the user app's window.
	
	// Open the connection to the camera drivers, this function should be called once, usually at the 
	// start of the app, a corresponding call to close_cam is made at the end.
	//
	if ( open_cam(CAM_CLIENT_USER_TYPE) == 0)
	{
		AfxMessageBox("Could not connect to camera");
		return TRUE;
	}
	
	// Use the enumerate function to collect info about the currently connected cameras
	// The camera id returned is used in functions such as alloc_capture to identify 
	// a particular camera.
	//
	CAM_IDENTIFICATION ident[10]; // make space for a number of camera identification structs
	unsigned long num_cameras=0;
	
	if ( (num_cameras = enumerate_cameras(ident,10)) ==0 )
	{
		AfxMessageBox("Could not enumerate cameras");
		return TRUE;
	}

	// Allocate a capture channel on a camera for our capture stream. In this case we use the id of the first 
	// '0th' camera from the one or more cameras that may have been enumerated. 
	//
	// Up to four capture channels per camera may be configured for different purposes, each of which can operate 
	// independently.
	//  
	// The timer capture handle is stored in a global variable so we can retrieve information about the capture stream
	// in other places in this example. 
	//
	if ( (gTimerCapture = alloc_capture(ident[0].id)) == 0 )
	{
		AfxMessageBox("Could not allocate a capture");
		return TRUE;
	}
	
	// Configure our newly allocated stream and start the actual capture stream to the user app's window
	//
	DEST_WINDOW destwin={0};	// The window on the screen where we wish to render the stream
	CAM_WINDOW camwin={0};		// The area of the camera sensor that we wish to capture
	CAPTURE_IMAGE_ADJUSTMENT image_adjustment={0};		// The brightness and contrast adjustment
	
	double frame_rate = 10.0;		// number of frames / sec for the stream
	long resolution=1;				// resolution of the captured image i.e. x1, x2, x4	
	double integration_time = 40.0;	// image sensor integration 'exposure' time
	double gain = 4.0;				// image sensor gain 

	// Use a windows function to get the size of the window for this example code
	RECT r;
	CStatic * pDisplayWindow = (CStatic *) GetDlgItem(IDC_STATIC_FRAME1); // this is the frame on the dialog app
	pDisplayWindow->GetWindowRect(&r); 

	// And define the position, size and handle of the user app's window where the stream will be displayed
	destwin.hwnd = pDisplayWindow->m_hWnd; 
	destwin.ox = 0;
	destwin.oy = 0;
	destwin.dx = r.right - r.left;	// width
	destwin.dy = r.bottom - r.top;	// height

	// Define the centre and size of the region of the camera sensor pixels to be captured
	camwin.cx = 0;
	camwin.cy = 0;
	camwin.dx = 1024; // 2048 x 1536 would be the full size of the sensor
	camwin.dy = 768;

	// Setup the default brightness and contrast control, rgbColourAdjust is applied equally to red, green and 
	// blue colour channels, the other adjustments are applied individually.
	image_adjustment.rgbColourAdjust.brightness = 0.0;
	image_adjustment.rgbColourAdjust.contrast = 1.0;
	image_adjustment.redColourAdjust.brightness = 0.0;
	image_adjustment.redColourAdjust.contrast = 1.0;
	image_adjustment.greenColourAdjust.brightness = 0.0;
	image_adjustment.greenColourAdjust.contrast = 1.0;
	image_adjustment.blueColourAdjust.brightness = 0.0;
	image_adjustment.blueColourAdjust.contrast = 1.0;

	// Start the timer stream to the window
	if( setup_timer_capture(gTimerCapture, frame_rate, &destwin, CAM_STANDARD_RES_FULL_SPEED, &camwin, resolution, integration_time, gain, &image_adjustment ) ==0 )
	{
		AfxMessageBox("Could not setup a timer capture");
		return TRUE;
	}

	// Optionally setup the auto image and exposure adjustment parameters
	CAPTURE_AUTO_ADJUST_PARAMS adjust_params={0};

    // Enable the auto adjustment
	adjust_params.adjust_mode = CAPTURE_AUTO_ADJUST_ON;						

    // To prevent very dark or very bright pixels from affecting the adjustment, we can specify
	// the percentage of pixels to ignore
	adjust_params.max_threshold = 10.0;										
    adjust_params.min_threshold = 10.0;										

    // Set the type of colour adjusment, other types may be selected
	adjust_params.adjustment_type = CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR;	

    // Set the mode of exposure adjusment, other modes may be selected
	// The nominal, min and max values define the working range of each parameter.
	adjust_params.exposure.exposure_mode = CAPTURE_AUTO_EXPOSURE_GAIN;		
    adjust_params.exposure.nominal_gain = 1;
    adjust_params.exposure.max_gain = 32.0;
    adjust_params.exposure.min_gain = 0.25;
    adjust_params.exposure.max_integration_time = 100;
    adjust_params.exposure.nominal_integration_time = 40;
    adjust_params.exposure.min_integration_time = 1;
    
	// Setup the auto adjustment on our timer capture stream
	if( setup_auto_adjust(gTimerCapture,&adjust_params) ==0)
	{
		AfxMessageBox("Could not setup auto adjust parameters");
		return TRUE;
	}
	open_light();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExample1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExample1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExample1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CExample1Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
	if(gTimerCapture)
	{
		// reset and free our timer capture using its handle that we stored earlier
		reset_capture(gTimerCapture);
		free_capture(gTimerCapture);
		gTimerCapture = 0;
	}

	// and close the connection to the camera drivers
	close_light();
	close_cam();
}

void CExample1Dlg::OnButtonCapture() 
{
	// TODO: Add your control notification handler code here
	unsigned long CaptureHandle=0;
	
	// Use the enumerate function to collect info about the currently connected cameras
	// The camera id returned is used in functions such as alloc_capture to identify 
	// a particular camera.
	//
	// This is really setup code that would be called at the start of an application
	//
	CAM_IDENTIFICATION ident[10]; // make space for a number of camera identification structs
	unsigned long num_cameras=0;
	
	if ( (num_cameras = enumerate_cameras(ident,10)) ==0 )
	{
		AfxMessageBox("Could not enumerate cameras");
		return;
	}

	// Allocate a capture channel on a camera for our capture stream. In this case we use the id of the first 
	// '0th' camera from the one or more cameras that may have been enumerated. 
	//
	// Up to four capture channels per camera may be configured for different purposes, each of which can operate 
	// independently.
	//  
	// The capture handle is stored locally and we free it when we are done so that the capture stream is available
	// for other operations
	//
	if ( (CaptureHandle = alloc_capture(ident[0].id)) == 0 )
	{
		AfxMessageBox("Could not allocate a capture");
		return;
	}

	// Configure our newly allocated stream 
	//
	CAM_WINDOW camwin={0};		// The area of the camera sensor that we wish to capture
	CAPTURE_IMAGE_ADJUSTMENT image_adjustment={0};		// The brightness and contrast adjustment
	
	double frame_rate = 0.0;		// Not relevant for a still capture
	long resolution=1;				// resolution of the captured image i.e. x1, x2, x4	
	double integration_time = 40.0;	// image sensor integration 'exposure' time
	double gain = 4.0;				// image sensor gain 
	long frame_size = 0;			// the size of the frame will be returned by setup_capture
	
	// Define the centre and size of the region of the camera sensor pixels to be captured
	camwin.cx = 0;
	camwin.cy = 0;
	camwin.dx = 512; // 2048 x 1536 would be the full size of the sensor
	camwin.dy = 384;

	// Setup the default brightness and contrast control, rgbColourAdjust is applied equally to red, green and 
	// blue colour channels, the other adjustments are applied individually.
	image_adjustment.rgbColourAdjust.brightness = 0.0;
	image_adjustment.rgbColourAdjust.contrast = 1.0;
	image_adjustment.redColourAdjust.brightness = 0.0;
	image_adjustment.redColourAdjust.contrast = 1.0;
	image_adjustment.greenColourAdjust.brightness = 0.0;
	image_adjustment.greenColourAdjust.contrast = 1.0;
	image_adjustment.blueColourAdjust.brightness = 0.0;
	image_adjustment.blueColourAdjust.contrast = 1.0;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// The following 'commented out' section shows how we could have read the settings from the timer capture stream that
// we setup at the start and use them to configure the still capture
//
//	CAPTURE_REQUIREMENT_PARAMS timer_capture_params={0};
//
//	if( (get_capture_params(gTimerCapture,&timer_capture_params))==0)
//	{
//		AfxMessageBox("Could not get the current timer capture parameters");
//		return;
//	}
//
//	camwin=timer_capture_params.cam;											
//	image_adjustment=timer_capture_params.image_adjustment;	
//	resolution=timer_capture_params.res;							
//	integration_time = timer_capture_params.integration_time;	
//	gain = timer_capture_params.gain;							
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// Setup the single shot 'immediate' capture
	if( setup_capture(CaptureHandle, CAM_STANDARD_RES_FULL_SPEED, frame_rate, &camwin, resolution, integration_time, gain, CAPTURE_IMMEDIATE, CAM_RGB24, &frame_size, &image_adjustment ) ==0 )
	{
		AfxMessageBox("Could not setup a capture");
		return;
	}

	// This function is used to start/stop/freeze/frame advance a capture stream. In the case of a CAPTURE_IMMEDIATE stream, 
	// it will trigger a new capture each time it is called with frame advance.
	if( capture_control(CaptureHandle, CAPTURE_CONTROL_TYPE_FRAME_ADVANCE)==0)
	{
		AfxMessageBox("Could not advance the capture frame");
		free_capture(CaptureHandle);
		return;
	}

	// wait until the frame has arrived in our buffer
	while ( capture_occured(CaptureHandle,NULL) == FALSE)
	{
	// Please note, the code is written this way for clarity and should not be used in a real application 
	// as the 'while' loop could loop forever if there was a problem 
	}
	
	// use a standard windows function to allocate space for our incoming capture data
	unsigned char *pCaptureData=NULL;
	if( (pCaptureData = (unsigned char *) malloc(frame_size))==NULL)
	{
		AfxMessageBox("Could not allocate memory for local frame storage");
		free_capture(CaptureHandle);
		return;
	}

	// And copy it to our local frame buffer with the frame info too...
	CAPTURE_FRAME_INFO frame_info={0};
	if( copy_capture_buffer(CaptureHandle,pCaptureData,&frame_info) == 0)
	{
		AfxMessageBox("Could not copy the frame data to local buffer");
		free_capture(CaptureHandle);
		return;
	}

	// captures are a limited resource, so we free this one when we are finished and have the data
	free_capture(CaptureHandle);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// The following section is just to show some data manipulation for this example app
// in this case swapping the colours around

	for (long i=0; i<frame_info.params.frame_size/3;i++)
	{
		unsigned char ch1 = pCaptureData[i*3+0];
		unsigned char ch2 = pCaptureData[i*3+1];
		unsigned char ch3 = pCaptureData[i*3+2];

		pCaptureData[i*3+0] = ch2;
		pCaptureData[i*3+1] = ch3;
		pCaptureData[i*3+2] = ch1;
	}

	// Define a 24 bit bmp that matches our data
	BITMAPINFO bmpinfo={sizeof(BITMAPINFOHEADER),frame_info.params.cam.dx,-frame_info.params.cam.dy,1,24,BI_RGB,0};
	// Get the display window frame
	CStatic * pDisplayWindow = (CStatic *) GetDlgItem(IDC_STATIC_FRAME2); // this is the frame on the dialog
	RECT r;
	pDisplayWindow->GetWindowRect(&r); 

	// and blt to window
	CDC* pDC  = pDisplayWindow->GetDC();
	SetStretchBltMode(pDC->m_hDC, STRETCH_HALFTONE);
    StretchDIBits(pDC->m_hDC, 0, 0, r.right - r.left, r.bottom - r.top, 0, 0, frame_info.params.cam.dx, frame_info.params.cam.dy, pCaptureData, &bmpinfo, DIB_RGB_COLORS, SRCCOPY);
	
	// and free the frame memory that we created earlier
	free(pCaptureData);
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}

void CExample1Dlg::OnLighting()
{
    // all on or off
	if (m_LightsCheckBox.GetCheck() != 0)
	{
        write_light(RING_WIDTH, 0, read_light(RING_WIDTH_MAX, 0));
        write_light(ENABLE, 0, 1);
        write_light(RING_ENABLE, 0, 1);
        write_light(RING_POWER, 0, 255);
	}
    else
	{
        write_light(ENABLE, 0, 0);
        write_light(RING_ENABLE, 0, 0);
	}
}
