#pragma once

#include "StillPictureForm.h"
#include "CameraSelectForm.h"
#include "lightingform.h"
#include "imageselectform.h"

namespace CPlusPlusSample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::ComponentModel;
	using namespace System::Runtime::InteropServices;
	using namespace Microsoft::Win32;
	using namespace System::Reflection;
	using namespace System::IO;
	using namespace System::Drawing::Imaging;

    extern void OnPictureClosed(Object ^sender, StillPictureFormEventArgs ^e);

	/// <summary>
	/// Summary for CPlusPlusSampleForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class CPlusPlusSampleForm : public System::Windows::Forms::Form
	{
	public:
		CPlusPlusSampleForm(void)
		{
			InitializeComponent();
			m_CamLibHandle = 0;
            m_bCapturing = false;
            m_bCapturingStill = false;
            m_nSkipCount = 0;
            m_nPictureIndex = 0;
            m_bUsingLights = false;
			g_FormPtr = this;
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~CPlusPlusSampleForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Panel^  PicturePanel;
	private: System::Windows::Forms::Button^  VideoButton;
	private: System::Windows::Forms::Button^  CaptureButton;
	private: System::Windows::Forms::Button^  SaveImageButton;
	private: System::Windows::Forms::Panel^  StatsPanel;
	private: System::Windows::Forms::CheckBox^  HistogramCheckBox;
	private: System::Windows::Forms::Button^  LightingButton;
	private: System::Windows::Forms::Button^  CloseButton;
	private: System::Windows::Forms::TextBox^  FocusTextBox;
	private: System::Windows::Forms::Label^  FocusLabel;
	private: System::Windows::Forms::TextBox^  FrameNumberTextBox;

	private: System::Windows::Forms::Label^  FrameNumberLabel;
	private: System::Windows::Forms::TextBox^  FrameQualityTextBox;

	private: System::Windows::Forms::Label^  FrameQualityLabel;
	private: System::Windows::Forms::Label^  IntegrationTimeLabel;
	private: System::Windows::Forms::TextBox^  IntegrationTimeTextBox;
	private: System::Windows::Forms::Timer^  StillTimer;
	private: System::Windows::Forms::Timer^  ChainTimer;
	private: System::ComponentModel::IContainer^  components;
	public: static CPlusPlusSampleForm ^GlobalForm(void) {return g_FormPtr;}
	static CPlusPlusSampleForm ^g_FormPtr;

	private:
        unsigned int m_CamLibHandle;
        UInt32 m_NumCameras;
		array<Deva::Camlib::CAM_IDENTIFICATION> ^m_Idents;
        UInt32 m_CameraId;
        UInt32 m_CaptureId;
        UInt32 m_StillCaptureId;
        UInt32 m_ChainCaptureId;
        bool m_bCapturing;
        bool m_bCapturingStill;
        long m_BuffSize;
        array<StillPictureForm ^> ^m_Pics;
        int m_nPictureIndex;
        int m_nSkipCount;

	private:
        bool m_bUsingLights;

	protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->PicturePanel = (gcnew System::Windows::Forms::Panel());
			this->VideoButton = (gcnew System::Windows::Forms::Button());
			this->CaptureButton = (gcnew System::Windows::Forms::Button());
			this->SaveImageButton = (gcnew System::Windows::Forms::Button());
			this->StatsPanel = (gcnew System::Windows::Forms::Panel());
			this->IntegrationTimeTextBox = (gcnew System::Windows::Forms::TextBox());
			this->IntegrationTimeLabel = (gcnew System::Windows::Forms::Label());
			this->FrameQualityTextBox = (gcnew System::Windows::Forms::TextBox());
			this->FrameQualityLabel = (gcnew System::Windows::Forms::Label());
			this->FrameNumberTextBox = (gcnew System::Windows::Forms::TextBox());
			this->FrameNumberLabel = (gcnew System::Windows::Forms::Label());
			this->FocusTextBox = (gcnew System::Windows::Forms::TextBox());
			this->FocusLabel = (gcnew System::Windows::Forms::Label());
			this->HistogramCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->LightingButton = (gcnew System::Windows::Forms::Button());
			this->CloseButton = (gcnew System::Windows::Forms::Button());
			this->StillTimer = (gcnew System::Windows::Forms::Timer(this->components));
			this->ChainTimer = (gcnew System::Windows::Forms::Timer(this->components));
			this->StatsPanel->SuspendLayout();
			this->SuspendLayout();
			// 
			// PicturePanel
			// 
			this->PicturePanel->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->PicturePanel->Location = System::Drawing::Point(0, 0);
			this->PicturePanel->Name = L"PicturePanel";
			this->PicturePanel->Size = System::Drawing::Size(512, 384);
			this->PicturePanel->TabIndex = 0;
			// 
			// VideoButton
			// 
			this->VideoButton->Location = System::Drawing::Point(548, 43);
			this->VideoButton->Name = L"VideoButton";
			this->VideoButton->Size = System::Drawing::Size(75, 23);
			this->VideoButton->TabIndex = 0;
			this->VideoButton->Text = L"Start";
			this->VideoButton->UseVisualStyleBackColor = true;
			this->VideoButton->Click += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnCapture);
			// 
			// CaptureButton
			// 
			this->CaptureButton->Location = System::Drawing::Point(548, 84);
			this->CaptureButton->Name = L"CaptureButton";
			this->CaptureButton->Size = System::Drawing::Size(75, 23);
			this->CaptureButton->TabIndex = 1;
			this->CaptureButton->Text = L"Capture Still";
			this->CaptureButton->UseVisualStyleBackColor = true;
			this->CaptureButton->Click += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnCaptureStill);
			// 
			// SaveImageButton
			// 
			this->SaveImageButton->Location = System::Drawing::Point(548, 128);
			this->SaveImageButton->Name = L"SaveImageButton";
			this->SaveImageButton->Size = System::Drawing::Size(75, 22);
			this->SaveImageButton->TabIndex = 2;
			this->SaveImageButton->Text = L"Save Image";
			this->SaveImageButton->UseVisualStyleBackColor = true;
			this->SaveImageButton->Click += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnSaveImage);
			// 
			// StatsPanel
			// 
			this->StatsPanel->Controls->Add(this->IntegrationTimeTextBox);
			this->StatsPanel->Controls->Add(this->IntegrationTimeLabel);
			this->StatsPanel->Controls->Add(this->FrameQualityTextBox);
			this->StatsPanel->Controls->Add(this->FrameQualityLabel);
			this->StatsPanel->Controls->Add(this->FrameNumberTextBox);
			this->StatsPanel->Controls->Add(this->FrameNumberLabel);
			this->StatsPanel->Controls->Add(this->FocusTextBox);
			this->StatsPanel->Controls->Add(this->FocusLabel);
			this->StatsPanel->Location = System::Drawing::Point(530, 168);
			this->StatsPanel->Name = L"StatsPanel";
			this->StatsPanel->Size = System::Drawing::Size(194, 164);
			this->StatsPanel->TabIndex = 4;
			// 
			// IntegrationTimeTextBox
			// 
			this->IntegrationTimeTextBox->Location = System::Drawing::Point(85, 123);
			this->IntegrationTimeTextBox->Name = L"IntegrationTimeTextBox";
			this->IntegrationTimeTextBox->ReadOnly = true;
			this->IntegrationTimeTextBox->Size = System::Drawing::Size(100, 20);
			this->IntegrationTimeTextBox->TabIndex = 7;
			this->IntegrationTimeTextBox->TabStop = false;
			// 
			// IntegrationTimeLabel
			// 
			this->IntegrationTimeLabel->AutoSize = true;
			this->IntegrationTimeLabel->Location = System::Drawing::Point(4, 130);
			this->IntegrationTimeLabel->Name = L"IntegrationTimeLabel";
			this->IntegrationTimeLabel->Size = System::Drawing::Size(83, 13);
			this->IntegrationTimeLabel->TabIndex = 6;
			this->IntegrationTimeLabel->Text = L"Integration Time";
			// 
			// FrameQualityTextBox
			// 
			this->FrameQualityTextBox->Location = System::Drawing::Point(85, 84);
			this->FrameQualityTextBox->Name = L"FrameQualityTextBox";
			this->FrameQualityTextBox->ReadOnly = true;
			this->FrameQualityTextBox->Size = System::Drawing::Size(100, 20);
			this->FrameQualityTextBox->TabIndex = 5;
			this->FrameQualityTextBox->TabStop = false;
			// 
			// FrameQualityLabel
			// 
			this->FrameQualityLabel->AutoSize = true;
			this->FrameQualityLabel->Location = System::Drawing::Point(4, 91);
			this->FrameQualityLabel->Name = L"FrameQualityLabel";
			this->FrameQualityLabel->Size = System::Drawing::Size(71, 13);
			this->FrameQualityLabel->TabIndex = 4;
			this->FrameQualityLabel->Text = L"Frame Quality";
			// 
			// FrameNumberTextBox
			// 
			this->FrameNumberTextBox->Location = System::Drawing::Point(85, 48);
			this->FrameNumberTextBox->Name = L"FrameNumberTextBox";
			this->FrameNumberTextBox->ReadOnly = true;
			this->FrameNumberTextBox->Size = System::Drawing::Size(100, 20);
			this->FrameNumberTextBox->TabIndex = 3;
			this->FrameNumberTextBox->TabStop = false;
			// 
			// FrameNumberLabel
			// 
			this->FrameNumberLabel->AutoSize = true;
			this->FrameNumberLabel->Location = System::Drawing::Point(4, 55);
			this->FrameNumberLabel->Name = L"FrameNumberLabel";
			this->FrameNumberLabel->Size = System::Drawing::Size(76, 13);
			this->FrameNumberLabel->TabIndex = 2;
			this->FrameNumberLabel->Text = L"Frame Number";
			// 
			// FocusTextBox
			// 
			this->FocusTextBox->Location = System::Drawing::Point(85, 13);
			this->FocusTextBox->Name = L"FocusTextBox";
			this->FocusTextBox->ReadOnly = true;
			this->FocusTextBox->Size = System::Drawing::Size(100, 20);
			this->FocusTextBox->TabIndex = 1;
			this->FocusTextBox->TabStop = false;
			// 
			// FocusLabel
			// 
			this->FocusLabel->AutoSize = true;
			this->FocusLabel->Location = System::Drawing::Point(4, 16);
			this->FocusLabel->Name = L"FocusLabel";
			this->FocusLabel->Size = System::Drawing::Size(67, 13);
			this->FocusLabel->TabIndex = 0;
			this->FocusLabel->Text = L"Focus Score";
			// 
			// HistogramCheckBox
			// 
			this->HistogramCheckBox->AutoSize = true;
			this->HistogramCheckBox->Location = System::Drawing::Point(658, 67);
			this->HistogramCheckBox->Name = L"HistogramCheckBox";
			this->HistogramCheckBox->Size = System::Drawing::Size(73, 17);
			this->HistogramCheckBox->TabIndex = 3;
			this->HistogramCheckBox->Text = L"Histogram";
			this->HistogramCheckBox->UseVisualStyleBackColor = true;
			this->HistogramCheckBox->CheckedChanged += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnHistogramChanged);
			// 
			// LightingButton
			// 
			this->LightingButton->Enabled = false;
			this->LightingButton->Location = System::Drawing::Point(548, 376);
			this->LightingButton->Name = L"LightingButton";
			this->LightingButton->Size = System::Drawing::Size(75, 23);
			this->LightingButton->TabIndex = 4;
			this->LightingButton->Text = L"Lighting";
			this->LightingButton->UseVisualStyleBackColor = true;
			this->LightingButton->Visible = false;
			this->LightingButton->Click += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnLighting);
			// 
			// CloseButton
			// 
			this->CloseButton->Location = System::Drawing::Point(548, 420);
			this->CloseButton->Name = L"CloseButton";
			this->CloseButton->Size = System::Drawing::Size(75, 23);
			this->CloseButton->TabIndex = 5;
			this->CloseButton->Text = L"Close";
			this->CloseButton->UseVisualStyleBackColor = true;
			this->CloseButton->Click += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnClose);
			// 
			// StillTimer
			// 
			this->StillTimer->Interval = 1;
			this->StillTimer->Tick += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnTimerTick);
			// 
			// ChainTimer
			// 
			this->ChainTimer->Interval = 10;
			this->ChainTimer->Tick += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnChainTimer);
			// 
			// CPlusPlusSampleForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(800, 493);
			this->Controls->Add(this->CloseButton);
			this->Controls->Add(this->LightingButton);
			this->Controls->Add(this->HistogramCheckBox);
			this->Controls->Add(this->StatsPanel);
			this->Controls->Add(this->SaveImageButton);
			this->Controls->Add(this->CaptureButton);
			this->Controls->Add(this->VideoButton);
			this->Controls->Add(this->PicturePanel);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->Name = L"CPlusPlusSampleForm";
			this->Text = L"Deva Camera Sample";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &CPlusPlusSampleForm::OnClosing);
			this->Load += gcnew System::EventHandler(this, &CPlusPlusSampleForm::OnLoad);
			this->StatsPanel->ResumeLayout(false);
			this->StatsPanel->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: System::Void OnCapture(System::Object^  sender, System::EventArgs^  e) {
            if (!m_bCapturing)      // start capturing
            {
                m_bCapturing = true;
                this->VideoButton->Text = "Stop";
                this->CaptureButton->Enabled = true;
                this->HistogramCheckBox->Checked = false;
                this->HistogramCheckBox->Enabled = true;
                // Create a timer capture that we leave running this draws itsself into the window area that we specify.
				m_CaptureId = Deva::Camlib::alloc_capture(m_CameraId);
                if (m_CaptureId == 0)       // error no capture
                {
					MessageBox::Show("Error on alloc_capture");
                    this->VideoButton->Text = "Start";
                    m_bCapturing = false;
                    this->CaptureButton->Enabled = false;
                }
				Deva::Camlib::reset_capture(m_CaptureId);
				Deva::Camlib::DEST_WINDOW DestWnd;
                DestWnd.hwnd = this->PicturePanel->Handle;
                DestWnd.dx = this->PicturePanel->Width;
                DestWnd.dy = this->PicturePanel->Height;
                DestWnd.ox = this->PicturePanel->Left;
                DestWnd.oy = this->PicturePanel->Top;
				Deva::Camlib::CAM_OPERATION_MODES OpMode;
				OpMode = Deva::Camlib::CAM_OPERATION_MODES::CAM_STANDARD_RES_FULL_SPEED;
				Deva::Camlib::CAM_WINDOW CamWnd;
                CamWnd.cx = 0;
                CamWnd.cy = 0;
                CamWnd.dx = 512;
                CamWnd.dy = 384;
				Deva::Camlib::CAPTURE_IMAGE_ADJUSTMENT ImageAdj;
                ImageAdj.rgbColourAdjust.brightness = 0.0;
                ImageAdj.rgbColourAdjust.contrast = 1.0;
                ImageAdj.redColourAdjust.brightness = 0.0;
                ImageAdj.redColourAdjust.contrast = 1.0;
                ImageAdj.greenColourAdjust.brightness = 0.0;
                ImageAdj.greenColourAdjust.contrast = 1.0;
                ImageAdj.blueColourAdjust.brightness = 0.0;
                ImageAdj.blueColourAdjust.contrast = 1.0;
				if (Deva::Camlib::setup_timer_capture(m_CaptureId, 5.0,DestWnd, OpMode,CamWnd, 1, 100, 1.0,ImageAdj) == 0)
                {
					MessageBox::Show("Error on setup_timer_capture");
                    this->VideoButton->Text = "Start";
                    m_bCapturing = false;
                    this->CaptureButton->Enabled = false;
					Deva::Camlib::reset_capture(m_CaptureId);
					Deva::Camlib::free_capture(m_CaptureId);
                    m_CaptureId = 0;
                }
                // set it up to auto-adjust image quality
				Deva::Camlib::CAPTURE_AUTO_ADJUST_PARAMS adjust_params;
				adjust_params.adjust_mode = Deva::Camlib::CAPTURE_AUTO_ADJUST_MODES::CAPTURE_AUTO_ADJUST_ON;
                adjust_params.max_threshold = 1.0;
                adjust_params.min_threshold = 1.0;
				adjust_params.adjustment_type = Deva::Camlib::CAPTURE_IMAGE_ADUSTMENT_TYPES::CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR;
				adjust_params.exposure.exposure_mode = Deva::Camlib::CAPTURE_AUTO_EXPOSURE_MODES::CAPTURE_AUTO_EXPOSURE_GAIN;
                adjust_params.exposure.nominal_gain = 1;
                adjust_params.exposure.max_gain = 32.0;
                adjust_params.exposure.min_gain = 0.25;
                adjust_params.exposure.max_integration_time = 100;
                adjust_params.exposure.nominal_integration_time = 20;
                adjust_params.exposure.min_integration_time = 1;
				if (Deva::Camlib::setup_auto_adjust(m_CaptureId,adjust_params) == 0)
                {
					MessageBox::Show("Error on setup_auto_adjust");
                    this->VideoButton->Text = "Start";
                    m_bCapturing = false;
                    this->CaptureButton->Enabled = false;
					Deva::Camlib::reset_capture(m_CaptureId);
					Deva::Camlib::free_capture(m_CaptureId);
                    m_CaptureId = 0;
                }
                // create a capture for a still picture this will not capture any frames untill we tell it too, and we have to
                // retrieve, process and display the data ourselves. We use a timer to check for available data having requested a frame.
				m_StillCaptureId = Deva::Camlib::alloc_capture(m_CameraId);
                if (m_StillCaptureId == 0)       // error no capture
                {
					MessageBox::Show("Error on alloc_capture for secondary capture");
                    this->CaptureButton->Enabled = false;
                }
				Deva::Camlib::reset_capture(m_StillCaptureId);
				Deva::Camlib::CAM_OPERATION_MODES StillOpMode;
				StillOpMode = Deva::Camlib::CAM_OPERATION_MODES::CAM_STANDARD_RES_FULL_SPEED;
				Deva::Camlib::CAM_WINDOW StillCamWnd;
                StillCamWnd.cx = 0;
                StillCamWnd.cy = 0;
                StillCamWnd.dx = 2048;
                StillCamWnd.dy = 1536;
				Deva::Camlib::CAPTURE_IMAGE_ADJUSTMENT StillImageAdj;
                StillImageAdj.rgbColourAdjust.brightness = 0.0;
                StillImageAdj.rgbColourAdjust.contrast = 1.0;
                StillImageAdj.redColourAdjust.brightness = 0.0;
                StillImageAdj.redColourAdjust.contrast = 1.0;
                StillImageAdj.greenColourAdjust.brightness = 0.0;
                StillImageAdj.greenColourAdjust.contrast = 1.0;
                StillImageAdj.blueColourAdjust.brightness = 0.0;
                StillImageAdj.blueColourAdjust.contrast = 1.0;
				if (Deva::Camlib::setup_capture(m_StillCaptureId,StillOpMode, 1.0,StillCamWnd, 1, 100, 1.0,
					Deva::Camlib::CAM_CAPTURE_TYPES::CAPTURE_IMMEDIATE,Deva::Camlib::CAM_FORMAT_TYPES::CAM_RGB32,m_BuffSize,
                    ImageAdj) == 0)
                {
					MessageBox::Show("Error on setup_capture");
                    this->CaptureButton->Enabled = false;
					Deva::Camlib::reset_capture(m_StillCaptureId);
					Deva::Camlib::free_capture(m_StillCaptureId);
                    m_StillCaptureId = 0;
                }
				Deva::Camlib::CAPTURE_AUTO_ADJUST_PARAMS still_adjust_params;
				still_adjust_params.adjust_mode = Deva::Camlib::CAPTURE_AUTO_ADJUST_MODES::CAPTURE_AUTO_ADJUST_ON;
                still_adjust_params.max_threshold = 1.0;
                still_adjust_params.min_threshold = 1.0;
				still_adjust_params.adjustment_type = Deva::Camlib::CAPTURE_IMAGE_ADUSTMENT_TYPES::CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR;
				still_adjust_params.exposure.exposure_mode = Deva::Camlib::CAPTURE_AUTO_EXPOSURE_MODES::CAPTURE_AUTO_EXPOSURE_GAIN;
                still_adjust_params.exposure.nominal_gain = 1;
                still_adjust_params.exposure.max_gain = 32.0;
                still_adjust_params.exposure.min_gain = 0.25;
                still_adjust_params.exposure.max_integration_time = 100;
                still_adjust_params.exposure.nominal_integration_time = 20;
                still_adjust_params.exposure.min_integration_time = 1;
				if (Deva::Camlib::setup_auto_adjust(m_StillCaptureId,still_adjust_params) == 0)
                {
					MessageBox::Show("Error on secondary setup_auto_adjust");
                    m_bCapturing = false;
                    this->CaptureButton->Enabled = false;
					Deva::Camlib::reset_capture(m_StillCaptureId);
					Deva::Camlib::free_capture(m_StillCaptureId);
                    m_StillCaptureId = 0;
                }
                // create a capture that we will chain to the timer capture so that we can monitor the information about frames in the 
                // timer capture and show these in the UI. We use a timer to check for available data and extra the Frame info only.
				m_ChainCaptureId = Deva::Camlib::alloc_capture(m_CameraId);
                if (m_ChainCaptureId == 0)       // error no capture
                {
					MessageBox::Show("Error on alloc_capture for tertiary capture");
                    this->CaptureButton->Enabled = false;
                }
				if (Deva::Camlib::chain_capture(m_CaptureId, (int)m_ChainCaptureId) == 0)
                {
					MessageBox::Show("Error on chain_capture for tertiary capture");
                    this->CaptureButton->Enabled = false;
                }
                ChainTimer->Enabled = true;
            }
            else
            {
                this->VideoButton->Text = "Start";
                m_bCapturing = false;
                this->CaptureButton->Enabled = false;
                this->HistogramCheckBox->Checked = false;
                this->HistogramCheckBox->Enabled = false;
                if (m_CaptureId != 0)
                {
					Deva::Camlib::reset_capture(m_CaptureId);
					Deva::Camlib::free_capture(m_CaptureId);
                    m_CaptureId = 0;
                }
                if (m_StillCaptureId != 0)
                {
					Deva::Camlib::reset_capture(m_StillCaptureId);
					Deva::Camlib::free_capture(m_StillCaptureId);
                    m_StillCaptureId = 0;
                }
                if (m_ChainCaptureId != 0)
                {
					Deva::Camlib::reset_capture(m_ChainCaptureId);
					Deva::Camlib::free_capture(m_ChainCaptureId);
                    m_ChainCaptureId = 0;
                    ChainTimer->Enabled = false;
                }
            }
			 }

	private: System::Void OnCaptureStill(System::Object^  sender, System::EventArgs^  e) {
	            if (m_bCapturing && !m_bCapturingStill)
		        {
			        this->CaptureButton->Enabled = false;     // manually capture a single frame in hi-res
				    StillTimer->Enabled = true;
	                m_bCapturingStill = true;
		            m_nSkipCount = 3;
					Deva::Camlib::capture_control(m_StillCaptureId, Deva::Camlib::CAPTURE_CONTROL_TYPES::CAPTURE_CONTROL_TYPE_FRAME_ADVANCE);
				}
			 }

	private: System::Void OnSaveImage(System::Object^  sender, System::EventArgs^  e) {
            int nImageCount = 0;
            array<String ^> ^ImageNames;
            array<int> ^ImageIndices;
            for (int n = 0;n < m_nPictureIndex;n++)
            {
                if (m_Pics[n] != nullptr)
                {
                    nImageCount++;
                }
            }
            if (nImageCount > 0)
            {
                ImageNames = gcnew array<String ^> (nImageCount);
                ImageIndices = gcnew array<int> (nImageCount);
                int ImageIndex = 0;
                int nSelectedIndex = -1;
                for (int n = 0; n < m_nPictureIndex; n++)
                {
                    if (m_Pics[n] != nullptr)
                    {
                        if (n % 2 != 0)
                        {
                            ImageNames[ImageIndex] = ("Histogram " + (n / 2).ToString());
                            ImageIndices[ImageIndex] = n;
                            ImageIndex++;
                        }
                        else
                        {
                            ImageNames[ImageIndex] = ("Still Picture " + (n / 2).ToString());
                            ImageIndices[ImageIndex] = n;
                            ImageIndex++;
                        }
                    }
                }
                if (nImageCount > 1)
                {
                    ImageSelectForm ^SelectForm = gcnew ImageSelectForm(ImageNames, nImageCount);
					if (SelectForm->ShowDialog() == System::Windows::Forms::DialogResult::OK)
                    {
                        nSelectedIndex = ImageIndices[SelectForm->GetIndex()];
                    }
					else
					{
						return;
					}
                }
                else
                {
                    nSelectedIndex = ImageIndices[0];
                }
                SaveFileDialog ^FileDialog = gcnew SaveFileDialog();
				FileDialog->InitialDirectory = Environment::GetFolderPath(Environment::SpecialFolder::Personal);
                FileDialog->Filter = "jpg files (*.jpg)|*.jpg|Bmp files (*.bmp)|*.bmp|Gif files (*.gif)|*.gif|Png files (*.png)|*.png";
                FileDialog->FilterIndex = 0;
                FileDialog->CheckFileExists = false;
                FileDialog->RestoreDirectory = true;
                if (nSelectedIndex % 2 != 0)
                {
                    FileDialog->Title = "Select File for Image : " + "Histogram " + (nSelectedIndex / 2).ToString();
                }
                else
                {
                    FileDialog->Title = "Select File for Image : " + "Still Picture " + (nSelectedIndex / 2).ToString();
                }
				if (FileDialog->ShowDialog() == System::Windows::Forms::DialogResult::OK)
                {       // we have selected a file
                    switch (FileDialog->FilterIndex)
                    {
                        case 1:
							m_Pics[nSelectedIndex]->GetImage()->Save(FileDialog->FileName, ImageFormat::Jpeg);
                            break;

                        case 2:
							m_Pics[nSelectedIndex]->GetImage()->Save(FileDialog->FileName, ImageFormat::Bmp);
                            break;

                        case 3:
							m_Pics[nSelectedIndex]->GetImage()->Save(FileDialog->FileName, ImageFormat::Gif);
                            break;

                        case 4:
							m_Pics[nSelectedIndex]->GetImage()->Save(FileDialog->FileName, ImageFormat::Png);
                            break;
                    }
                }
                else
                {
                    return;
                }
            }
			 }

private: System::Void OnHistogramChanged(System::Object^  sender, System::EventArgs^  e) {
            if (HistogramCheckBox->Checked)
            {
				Deva::Camlib::capture_overlay(m_CaptureId, Deva::Camlib::CAPTURE_COORDINATE_TYPES::CAPTURE_COORDINATE_WINDOW,
				Deva::Camlib::CAPTURE_OVERLAY_TYPES::CAPTURE_OVERLAY_ADJUSTED_HISTOGRAM, 0, 0, 0, 0);
            }
            else
            {
				Deva::Camlib::capture_overlay(m_CaptureId, Deva::Camlib::CAPTURE_COORDINATE_TYPES::CAPTURE_COORDINATE_WINDOW,
				Deva::Camlib::CAPTURE_OVERLAY_TYPES::CAPTURE_OVERLAY_OFF, 0, 0, 0, 0);
            }
		 }

private: System::Void OnLighting(System::Object^  sender, System::EventArgs^  e) {
			 LightingButton->Enabled = false;
            LightingForm ^LightForm = gcnew LightingForm(LightingButton);
            LightForm->Show();
		 }

private: System::Void OnClose(System::Object^  sender, System::EventArgs^  e) {
            this->Close();
		 }

private: System::Void OnLoad(System::Object^  sender, System::EventArgs^  e) {
			 m_CamLibHandle = Deva::Camlib::open_cam(Deva::Camlib::CAM_CLIENT_TYPES::CAM_CLIENT_USER_TYPE);
            if (m_CamLibHandle == 0)
            {
				MessageBox::Show("Error on open_cam");
				this->Close();
				return;
            }
			Deva::Camlib::reset_cam();       // reset the camera drivers
			m_NumCameras = Deva::Camlib::num_cameras();
            if (m_NumCameras == 0)      // no cameras so we have a problem
            {
				MessageBox::Show("Error no Cameras");
				Deva::Camlib::close_cam();
				this->Close();
				return;
            }
			m_Idents = gcnew array<Deva::Camlib::CAM_IDENTIFICATION> (m_NumCameras);
			m_NumCameras = Deva::Camlib::enumerate_cameras(m_Idents, m_NumCameras);
            if (m_NumCameras > 1)       // we have more then 1 camera so select one
            {
                CameraSelectForm ^Select = gcnew CameraSelectForm(m_Idents, m_NumCameras);
				Select->ShowDialog();
                m_CameraId = (UInt32)m_Idents[Select->GetSelection()].id;
            }
            else
            {
                m_CameraId = (UInt32)m_Idents[0].id;
            }
            this->CaptureButton->Enabled = false;
            this->SaveImageButton->Enabled = false;
            this->VideoButton->Enabled = true;

			// complete re-write load the .net lightlib dll and check for failure
			try 
			{
				short Result;
				Result = Deva::Lghtlib::open_light();
				if (Result != 0)
				{
		            m_bUsingLights = false;
				}
                else
                {
                    LightingButton->Visible = true;
                    LightingButton->Enabled = true;
		            m_bUsingLights = true;
                }
			} catch (...)
			{
	            m_bUsingLights = false;
			}
		 }
		 
private: System::Void OnClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
            if (m_bCapturing)
            {
                m_bCapturing = false;
				Deva::Camlib::free_capture(m_CaptureId);
                if (m_StillCaptureId != 0)
                {
					Deva::Camlib::free_capture(m_StillCaptureId);
                }
                if (m_ChainCaptureId != 0)
                {
					Deva::Camlib::free_capture(m_ChainCaptureId);
                }
            }
			if ( m_CamLibHandle !=0 )
				Deva::Camlib::close_cam();
            if (m_bUsingLights)
            {
				Deva::Lghtlib::write_light((short)Deva::Lghtlib::COMMANDS::ENABLE,0,0);
				Deva::Lghtlib::write_light((short)Deva::Lghtlib::COMMANDS::RING_ENABLE,0,0);
				Deva::Lghtlib::close_light();
            }
		 }

private: System::Void OnChainTimer(System::Object^  sender, System::EventArgs^  e) {
			 Deva::Camlib::CAPTURE_FRAME_INFO FrameInfo;
			 array<Byte> ^Buffer = gcnew array<Byte> (512 * 384 * 4);
			if (Deva::Camlib::capture_occured(m_ChainCaptureId,FrameInfo) == 1)
            {
                // to get the frame metrics we need to call copy_capture buffer even though we don't need the data
				Deva::Camlib::copy_capture_buffer(m_ChainCaptureId,Buffer,FrameInfo);
				FocusTextBox->Text = FrameInfo.focus.ToString("N3");
                FrameNumberTextBox->Text = FrameInfo.frame_number.ToString("N3");
                FrameQualityTextBox->Text = FrameInfo.frame_quality.ToString("N3");
                IntegrationTimeTextBox->Text = FrameInfo.paramset.integration_time.ToString("N3");
            }
		 }

private: System::Void OnTimerTick(System::Object^  sender, System::EventArgs^  e) {
			 Deva::Camlib::CAPTURE_FRAME_INFO FrameInfo;
			 if (Deva::Camlib::capture_occured(m_StillCaptureId,FrameInfo) == 1)
            {
                array<Byte> ^Buffer = gcnew array<Byte> (m_BuffSize);
				if (Deva::Camlib::copy_capture_buffer(m_StillCaptureId,Buffer,FrameInfo) == 1)
                {
                    if (m_nSkipCount > 0)       // skip a few frames so that the auto-setup adjustment has time to work
                    {
                        m_nSkipCount--;
                        // get another frame from the camera
						Deva::Camlib::capture_control(m_StillCaptureId, Deva::Camlib::CAPTURE_CONTROL_TYPES::CAPTURE_CONTROL_TYPE_FRAME_ADVANCE);
                    }
                    else
                    {
                        // were done so display the data
                        Bitmap ^bmp = gcnew Bitmap(2048, 1536);
                        // Specify a pixel format.
						PixelFormat pxf = PixelFormat::Format32bppRgb;

                        // Lock the bitmap's bits.
                        Rectangle rect;
						rect.X = 0;
						rect.Y = 0;
						System::Drawing::Size sz(bmp->Width,bmp->Height);
						rect.Size = sz;
                        BitmapData ^bmpData =
						bmp->LockBits(rect, ImageLockMode::ReadWrite,
                                     pxf);

                        // Get the address of the first line.
                        IntPtr ptr = bmpData->Scan0;

                        // Declare an array to hold the bytes of the bitmap.
						Int32 numBytes = Math::Abs(bmpData->Stride) * bmpData->Height;

                        // Copy the RGB values back to the bitmap
						Marshal::Copy(Buffer, 0, ptr, numBytes);

                        // Unlock the bits.
                        bmp->UnlockBits(bmpData);

                        array<StillPictureForm ^> ^NewPics = gcnew array<StillPictureForm ^> (m_nPictureIndex + 1);
                        for (int i = 0; i < m_nPictureIndex; i++)
                        {
                            NewPics[i] = m_Pics[i];
                        }
                        NewPics[m_nPictureIndex] = gcnew StillPictureForm(bmp, ("Still Picture " + (m_nPictureIndex  / 2).ToString()), m_nPictureIndex);
						NewPics[m_nPictureIndex]->CloseEvent += gcnew StillPictureForm::CloseEventHandler(&OnPictureClosed);
                        NewPics[m_nPictureIndex]->Show();
                        NewPics[m_nPictureIndex]->Size = System::Drawing::Size(this->Width / 2,this->Height / 2);
                        m_nPictureIndex++;
                        m_Pics = NewPics;
                        // now the Histogram
                        bmp = gcnew Bitmap(256,256);
                        // Specify a pixel format.
						pxf = PixelFormat::Format32bppRgb;

                        // Lock the bitmap's bits.
						rect.X = 0;
						rect.Y = 0;
						System::Drawing::Size sz2(bmp->Width,bmp->Height);
						rect.Size = sz2;
                        bmpData =
						bmp->LockBits(rect, ImageLockMode::ReadWrite,
                                     pxf);

                        // Get the address of the first line.
                        ptr = bmpData->Scan0;

                        // Declare an array to hold the bytes of the bitmap.
						numBytes = Math::Abs(bmpData->Stride) * bmpData->Height;

						array<Int32> ^rgbValues = gcnew array<Int32> (numBytes / sizeof(Int32));

                        // Copy the RGB values into the array.
						System::Runtime::InteropServices::Marshal::Copy(ptr,rgbValues,0,numBytes / sizeof(Int32));

                        int nRow;
                        int nCol;
                        for (nRow = 0; nRow < bmpData->Height; nRow++)
                        {
							int nOffset = ((Math::Abs(bmpData->Stride) * nRow) / sizeof(Int32));
                            for (nCol = 0; nCol < bmpData->Width; nCol++)
                            {
                                rgbValues[nOffset  + nCol] = 0;
                            }
                        }
                        int nMax = 0;
                        for (int n = 0; n < 256; n++)
                        {
                            if (nMax < FrameInfo.redHist.bin[n])
                            {
                                nMax = FrameInfo.redHist.bin[n];
                            }
                            if (nMax < FrameInfo.greenHist.bin[n])
                            {
                                nMax = FrameInfo.greenHist.bin[n];
                            }
                            if (nMax < FrameInfo.blueHist.bin[n])
                            {
                                nMax = FrameInfo.blueHist.bin[n];
                            }
                        }
                        double dScale = 255.0 / nMax;
                        for (nCol = 0; nCol < bmpData->Width; nCol++)
                        {
							int nOffset = ((Math::Abs(bmpData->Stride) * (255 - (int)(FrameInfo.redHist.bin[nCol] * dScale ))) / sizeof(Int32));
                            rgbValues[nOffset + nCol] |= 0x00ff0000;
							nOffset = ((Math::Abs(bmpData->Stride) * (255 - (int)(FrameInfo.greenHist.bin[nCol] * dScale))) / sizeof(Int32));
                            rgbValues[nOffset + nCol] |= 0x0000ff00;
							nOffset = ((Math::Abs(bmpData->Stride) * (255 - (int)(FrameInfo.blueHist.bin[nCol] * dScale))) / sizeof(Int32));
                            rgbValues[nOffset + nCol] |= 0x000000ff;
                        }
                        // Copy the RGB values back to the bitmap
						System::Runtime::InteropServices::Marshal::Copy(rgbValues,0, ptr, numBytes / sizeof(Int32));
                        // Unlock the bits.
                        bmp->UnlockBits(bmpData);
						NewPics = gcnew array<StillPictureForm ^> (m_nPictureIndex + 1);
						for (int i = 0; i < m_nPictureIndex; i++)
                        {
                            NewPics[i] = m_Pics[i];
                        }
                        NewPics[m_nPictureIndex] = gcnew StillPictureForm(bmp, ("Histogram " + (m_nPictureIndex / 2).ToString()), m_nPictureIndex);
						NewPics[m_nPictureIndex]->CloseEvent += gcnew StillPictureForm::CloseEventHandler(&OnPictureClosed);
                        NewPics[m_nPictureIndex]->Show();
                        m_nPictureIndex++;
                        m_Pics = NewPics;
                        StillTimer->Enabled = false;     // re-enable still capture
                        this->CaptureButton->Enabled = true;
                        this->SaveImageButton->Enabled = true;
                        m_bCapturingStill = false;
                    }
                }
            }
	}
	public:
	void RemoveIndex(int nIndex)
	{
        m_Pics[nIndex] = nullptr;
        for (int i = 0; i < m_nPictureIndex; i++)
        {
            if (m_Pics[i] != nullptr)
            {
               return;
            }
        }
        this->SaveImageButton->Enabled = false;
	}
	};

    void OnPictureClosed(Object ^sender, StillPictureFormEventArgs ^e)
    {
		CPlusPlusSampleForm::GlobalForm()->RemoveIndex(e->nIndex());
    }
}

