using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DevaCameraSample;

namespace DevaCameraSample
{
    public partial class StillPictureForm : Form
    {
        public StillPictureForm(Bitmap Bmp, string Title, int nIndex)
        {
            InitializeComponent();
            this.Text = Title;
            this.PictureBox.Image = Bmp;
            m_nIndex = nIndex;
        }

        public Image GetImage()
        {
            return this.PictureBox.Image;
        }

        int m_nIndex;
        public delegate void CloseEventHandler(object sender, StillPictureFormEventArgs e);
        public event CloseEventHandler CloseEvent;
        protected virtual void OnCloseEvent(StillPictureFormEventArgs e)
        {
            if (CloseEvent != null)
                CloseEvent(this, e);
        }

        private void OnClosing(object sender, FormClosingEventArgs e)
        {
            StillPictureFormEventArgs Args = new StillPictureFormEventArgs(m_nIndex);
            OnCloseEvent(Args);
        }
    }
}