Public Class VBSampleForm

    Private m_Camlib As Deva.Camlib
    Private m_CamLibHandle As UInt32
    Private m_NumCameras As UInt32
    Private m_CameraId As UInt32
    Private m_CaptureId As UInt32
    Private m_ChainCaptureId As UInt32
    Private m_bCapturing As Boolean
    Private m_BuffSize As Int32
    Private adjust_params As Deva.Camlib.CAPTURE_AUTO_ADJUST_PARAMS
    Private m_bUsingLights As Boolean
    Private Sub OnCapture(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VideoButton.Click
        If m_CamLibHandle <> 0 Then
            If (m_bCapturing = False) Then      ' start capturing
                m_bCapturing = True
                VideoButton.Text = "Stop"
                ' Create a timer capture that we leave running this draws itsself into the window area that we specify.
                m_CaptureId = Deva.Camlib.alloc_capture(m_CameraId)
                If (m_CaptureId = 0) Then       ' error no capture
                    MessageBox.Show("Error on alloc_capture")
                    VideoButton.Text = "Start"
                    m_bCapturing = False
                    Return
                End If
                Deva.Camlib.reset_capture(m_CaptureId)
                Dim DestWnd As Deva.Camlib.DEST_WINDOW
                DestWnd.hwnd = PicturePanel.Handle
                DestWnd.dx = PicturePanel.Width
                DestWnd.dy = PicturePanel.Height
                DestWnd.ox = PicturePanel.Left
                DestWnd.oy = PicturePanel.Top
                Dim OpMode As Deva.Camlib.CAM_OPERATION_MODES
                OpMode = Deva.Camlib.CAM_OPERATION_MODES.CAM_STANDARD_RES_FULL_SPEED
                Dim CamWnd As Deva.Camlib.CAM_WINDOW
                CamWnd.cx = 0
                CamWnd.cy = 0
                CamWnd.dx = 512
                CamWnd.dy = 384
                Dim ImageAdj As Deva.Camlib.CAPTURE_IMAGE_ADJUSTMENT
                ImageAdj.rgbColourAdjust.brightness = 0.0
                ImageAdj.rgbColourAdjust.contrast = 1.0
                ImageAdj.redColourAdjust.brightness = 0.0
                ImageAdj.redColourAdjust.contrast = 1.0
                ImageAdj.greenColourAdjust.brightness = 0.0
                ImageAdj.greenColourAdjust.contrast = 1.0
                ImageAdj.blueColourAdjust.brightness = 0.0
                ImageAdj.blueColourAdjust.contrast = 1.0
                If (Deva.Camlib.setup_timer_capture(m_CaptureId, 5.0, DestWnd, OpMode, CamWnd, 1, 100, 1.0, ImageAdj) = 0) Then
                    MessageBox.Show("Error on setup_timer_capture")
                    VideoButton.Text = "Start"
                    m_bCapturing = False
                    Deva.Camlib.reset_capture(m_CaptureId)
                    Deva.Camlib.free_capture(m_CaptureId)
                    m_CaptureId = 0
                    Return
                End If
                ' set it up to auto-adjust image quality
                If (Deva.Camlib.setup_auto_adjust(m_CaptureId, adjust_params) = 0) Then
                    MessageBox.Show("Error on setup_auto_adjust")
                    VideoButton.Text = "Start"
                    m_bCapturing = False
                    Deva.Camlib.reset_capture(m_CaptureId)
                    Deva.Camlib.free_capture(m_CaptureId)
                    m_CaptureId = 0
                    Return
                End If
                ' create a capture that we will chain to the timer capture so that we can monitor the information about frames in the 
                ' timer capture and show these in the UI. We use a timer to check for available data and extra the Frame info only.
                m_ChainCaptureId = Deva.Camlib.alloc_capture(m_CameraId)
                If (m_ChainCaptureId = 0) Then       ' error no capture
                    MessageBox.Show("Error on alloc_capture for tertiary capture")
                End If
                If (Deva.Camlib.chain_capture(m_CaptureId, m_ChainCaptureId) = 0) Then
                    MessageBox.Show("Error on chain_capture for tertiary capture")
                End If
                ChainTimer.Enabled = True
                ModePanel.Enabled = True
            Else
                VideoButton.Text = "Start"
                m_bCapturing = False
                If (m_CaptureId <> 0) Then
                    Deva.Camlib.reset_capture(m_CaptureId)
                    Deva.Camlib.free_capture(m_CaptureId)
                    m_CaptureId = 0
                End If
                If (m_ChainCaptureId <> 0) Then
                    Deva.Camlib.reset_capture(m_ChainCaptureId)
                    Deva.Camlib.free_capture(m_ChainCaptureId)
                    m_ChainCaptureId = 0
                    ChainTimer.Enabled = False
                End If
                ModePanel.Enabled = False
            End If
        End If
    End Sub

    Private Sub OnClose(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        Close()
    End Sub

    Private Sub FormLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_bCapturing = False
        m_Camlib = New Deva.Camlib()
        m_CamLibHandle = Deva.Camlib.open_cam(Deva.Camlib.CAM_CLIENT_TYPES.CAM_CLIENT_USER_TYPE)
        If (m_CamLibHandle = 0) Then
            MessageBox.Show("Error on open_cam")
            Close()
            Return
        End If
        Deva.Camlib.reset_cam()       ' reset the camera drivers
        m_NumCameras = Deva.Camlib.num_cameras()
        If (m_NumCameras = 0) Then      ' no cameras so we have a problem
            MessageBox.Show("Error no Cameras")
            Deva.Camlib.close_cam()
            Close()
            Return
        End If
        Dim m_Idents(m_NumCameras) As Deva.Camlib.CAM_IDENTIFICATION
        m_NumCameras = Deva.Camlib.enumerate_cameras(m_Idents, m_NumCameras)
        m_CameraId = m_Idents(0).id
        VideoButton.Enabled = True
        m_CaptureId = 0
        adjust_params.adjust_mode = Deva.Camlib.CAPTURE_AUTO_ADJUST_MODES.CAPTURE_AUTO_ADJUST_ON
        adjust_params.max_threshold = 1.0
        adjust_params.min_threshold = 1.0
        adjust_params.adjustment_type = Deva.Camlib.CAPTURE_IMAGE_ADUSTMENT_TYPES.CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR
        adjust_params.exposure.exposure_mode = Deva.Camlib.CAPTURE_AUTO_EXPOSURE_MODES.CAPTURE_AUTO_EXPOSURE_GAIN
        adjust_params.exposure.nominal_gain = 1
        adjust_params.exposure.max_gain = 32.0
        adjust_params.exposure.min_gain = 0.25
        adjust_params.exposure.max_integration_time = 100
        adjust_params.exposure.nominal_integration_time = 20
        adjust_params.exposure.min_integration_time = 1
        AutoModeComboBox.Items.Add("Auto Off")
        AutoModeComboBox.Items.Add("Auto Levels")
        AutoModeComboBox.Items.Add("Auto Exposure")
        AutoModeComboBox.SelectedIndex = 2

        If Deva.Lghtlib.open_light() <> 0 Then
            m_bUsingLights = False
        Else
            m_bUsingLights = True
        End If

    End Sub

    Private Sub MyFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        ChainTimer.Enabled = False
        If (m_bCapturing) Then
            m_bCapturing = False
            Deva.Camlib.free_capture(m_CaptureId)
            If (m_ChainCaptureId <> 0) Then
                Deva.Camlib.free_capture(m_ChainCaptureId)
            End If
        End If

        If m_CamLibHandle <> 0 Then
            Deva.Camlib.close_cam()
        End If

        If m_bUsingLights = True Then
            Deva.Lghtlib.close_light()
        End If

    End Sub

    Private Sub OnChainTimer(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChainTimer.Tick
        Dim FrameInfo As Deva.Camlib.CAPTURE_FRAME_INFO = New Deva.Camlib.CAPTURE_FRAME_INFO
        Dim Buffer(512 * 384 * 4) As Byte
        If (Deva.Camlib.capture_occured(m_ChainCaptureId, FrameInfo) = 1) Then
            ' to get the frame metrics we need to call copy_capture buffer even though we don't need the data
            Deva.Camlib.copy_capture_buffer(m_ChainCaptureId, Buffer, FrameInfo)
            FocusTextBox.Text = FrameInfo.focus.ToString("N3")
            FrameNumberTextBox.Text = FrameInfo.frame_number.ToString("N3")
            FrameQualityTextBox.Text = FrameInfo.frame_quality.ToString("N3")
            IntegrationTimeTextBox.Text = FrameInfo.paramset.integration_time.ToString("N3")
        End If
    End Sub

    Private Sub OnApply(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyButton.Click
        If (m_bCapturing = True) Then
            OnCapture(sender, e)
            OnCapture(sender, e)
        End If
        ApplyButton.Enabled = False

    End Sub

    Private Sub OnAutoModeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutoModeComboBox.SelectedIndexChanged
        Select Case AutoModeComboBox.SelectedIndex

            Case 0
                adjust_params.exposure.exposure_mode = Deva.Camlib.CAPTURE_AUTO_EXPOSURE_MODES.CAPTURE_AUTO_EXPOSURE_OFF
                adjust_params.exposure.max_gain = 32.0
                adjust_params.exposure.min_gain = 0.25
                adjust_params.exposure.max_integration_time = 100.0
                adjust_params.exposure.min_integration_time = 1.0

                adjust_params.adjust_mode = Deva.Camlib.CAPTURE_AUTO_ADJUST_MODES.CAPTURE_AUTO_ADJUST_OFF
                adjust_params.adjustment_type = Deva.Camlib.CAPTURE_IMAGE_ADUSTMENT_TYPES.CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR
                adjust_params.max_threshold = 10.0
                adjust_params.min_threshold = 10.0

            Case 1
                adjust_params.exposure.exposure_mode = Deva.Camlib.CAPTURE_AUTO_EXPOSURE_MODES.CAPTURE_AUTO_EXPOSURE_OFF
                adjust_params.exposure.max_gain = 32.0
                adjust_params.exposure.min_gain = 0.25
                adjust_params.exposure.max_integration_time = 100.0
                adjust_params.exposure.min_integration_time = 1.0

                adjust_params.adjust_mode = Deva.Camlib.CAPTURE_AUTO_ADJUST_MODES.CAPTURE_AUTO_ADJUST_ON
                adjust_params.adjustment_type = Deva.Camlib.CAPTURE_IMAGE_ADUSTMENT_TYPES.CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR
                adjust_params.max_threshold = 10.0
                adjust_params.min_threshold = 10.0

            Case Else
                adjust_params.exposure.exposure_mode = Deva.Camlib.CAPTURE_AUTO_EXPOSURE_MODES.CAPTURE_AUTO_EXPOSURE_GAIN
                adjust_params.exposure.max_gain = 32.0
                adjust_params.exposure.min_gain = 0.25
                adjust_params.exposure.max_integration_time = 100.0
                adjust_params.exposure.min_integration_time = 1.0

                adjust_params.adjust_mode = Deva.Camlib.CAPTURE_AUTO_ADJUST_MODES.CAPTURE_AUTO_ADJUST_ON
                adjust_params.adjustment_type = Deva.Camlib.CAPTURE_IMAGE_ADUSTMENT_TYPES.CAPTURE_IMAGE_ADJUSTMENT_PER_COLOUR
                adjust_params.max_threshold = 10.0
                adjust_params.min_threshold = 10.0
        End Select
        ApplyButton.Enabled = True
    End Sub

    Private Sub OnLights(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LightsCheckBox.CheckedChanged
        ' all on or off
        If m_bUsingLights = True Then
            If LightsCheckBox.Checked = True Then
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.RING_WIDTH, 0, Deva.Lghtlib.read_light(Deva.Lghtlib.COMMANDS.RING_WIDTH_MAX, 0))
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.ENABLE, 0, 1)
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.RING_ENABLE, 0, 1)
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.RING_POWER, 0, 255)
            Else
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.ENABLE, 0, 0)
                Deva.Lghtlib.write_light(Deva.Lghtlib.COMMANDS.RING_ENABLE, 0, 0)
            End If
        End If
    End Sub

End Class
