/*----------------------------------------------------------------------------

	Light controller device driver header file

--------------------------------------------------------------------------

	Revision History.

----------------------------------------------------------------------------*/

#define LGHTLIB_INTERFACE_VERSION 0x01020300
#define LGHTLIB_LIBRARY_VERSION 0x02030400

#if !defined(__DEVLIB3)
#define __DEVLIB3
#endif

#if !defined(__ENCODER3)
#define __ENCODER3

enum COMMANDS
{
	NUM_UNITS = 7,UNIT_TYPE,VERSION_NUM,
	ENABLE = 10, READY, RING_LED_MODE,
	RING_ENABLE = 20,RING_POWER,RING_POWER_MAX,RING_WIDTH,RING_WIDTH_MAX,RING_DIRECTION,RING_DIRECTION_MAX,
	AUX1_ENABLE = 30,AUX1_POWER,AUX1_POWER_MAX,
	AUX2_ENABLE = 40,AUX2_POWER,AUX2_POWER_MAX,
	STEP_POSITION = 50,STEP_INPUTS,STEP_FEED,STEP_ACCEL,STEP_DECEL,STEP_KV,STEP_VFF,LIMIT_POSITION, NUM_STEPPERS,
	FOCUS_CAPTURE = 60,FOCUS_NUMBER,FOCUS_STATE, FOCUS_THRESHOLD
};

/*----------------------------------------------------------------------------

	Function definitions.

----------------------------------------------------------------------------*/
#ifdef _WIN32

#define	PTR_DEF
#define	FN_DEF __stdcall

#else

#define	PTR_DEF far
#define	FN_DEF _pascal

#endif

#ifdef __cplusplus

#define EXT_DEF extern "C"

#else

#define EXT_DEF

#endif	

EXT_DEF char PTR_DEF * FN_DEF lightlib_version(void);
EXT_DEF long FN_DEF read_light(short command,short channel);
EXT_DEF void FN_DEF write_light(short command,short channel,long value);
EXT_DEF short FN_DEF open_light(void);
EXT_DEF void FN_DEF close_light(void);

#endif

/*----------------------------------------------------------------------------

	End.

----------------------------------------------------------------------------*/
